//	T[{SG-90ƉxZT[MPU-6050𗘗pV[\[
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	svO	svI		T[{
portC	x	*	SCL	SDA	-	-	-	VR		I2CA{[
portD	-	-	-	-	-	-	-	-		

yATmega328PzyATmega88z
|543210---54321|
|CCCCCCGRVBBBBB|
>              |
|CDDDDDVGBBDDDB|
|601234--675670|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11-11001(D9)
Low: 11100010 (E2)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11001 (D9)
     |||||||+-- BOOTRST f[^V[gQ
     |||||++-- BOOTSZ[1:0] f[^V[gQ
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----111 (FF)
          +++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)

yTarget device = ATmega88z	Hoאݒ Low:01100010(62), Hi:11-11111(DF)
Low: 11100010 (E2)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
     |||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
          ||+-- BOOTRST f[^V[gQ
          ++-- BOOTSZ[1:0] f[^V[gQ

yrhz
Atmel Studio 7 (Version: 7.0.1931 - )
ATmega328P	8MHz/Ȃ
ATmega88V	8MHz/Ȃ
*/
/*
yXVz
2019/05	v0.10
	ESG90testvWFNgRs[AJJn
	
2019/05	v0.20
	Eo͑T[{̈肵ŒǏ]悤ɂȂ
		Program Memory Usage 	:	5078 bytes   62.0 % Full
		Data Memory Usage 		:	134 bytes   13.1 % Full

2019/05	v0.30
	E\[X𐮗
		Program Memory Usage 	:	5050 bytes   61.6 % Full
		Data Memory Usage 		:	141 bytes   13.8 % Full

2019/05	v1.00
	Esg90libŊ荞݃^C~O3ms3.3msɕύXB
		Program Memory Usage 	:	5050 bytes   61.6 % Full
		Data Memory Usage 		:	141 bytes   13.8 % Full
*/

#include <avr/io.h>
#include <avr/sleep.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "twilib.h"
#include "sg90lib.h"
#include "twiclcd/I2cCharLcdLib.h"
#include "mpu6050lib.h"

//̓T[{̓
#define SV_INPUT_DEG_0		0.54	//0.50--0.60msx
#define SV_INPUT_DEG_180	2.44	//2.40--2.50msx

//o̓T[{̓
#define SV_OUTPUT_DEG_0		0.60	//0.50--0.60msx
#define SV_OUTPUT_DEG_180	2.38	//2.40--2.50msx

//V[\[̌X
typedef	enum
{
	SEESAW_NEUTRAL,
	SEESAW_INPUTSIDE_UP,
	SEESAW_INPUTSIDE_DOWN,
	SEESAW_OUTPUTSIDE_UP = SEESAW_INPUTSIDE_DOWN,
	SEESAW_OUTPUTSIDE_DOWN = SEESAW_INPUTSIDE_UP
}
ESeesawTilt;

//T[{]p̏liT[{z[ƂȂpxj
#define SV_DEGREE_DEFAULT	90.0

//͑T[{̉]p̌El
//Eɏ̌ǍB
//EV[\[̋@\A+-30.0xx͈̔́B
#define SV_DEGREE_UPPER_LIMIT	(90.0 - 30.0)
#define SV_DEGREE_LOWER_LIMIT	(90.0 + 30.0)

//֐
static	void	WaitSec(uint8_t sec);
static	uint16_t	VolumeAdc(void);
static	float	VolumeToDegree(uint16_t volumeAdc);
static	void	MoveInputServo(TServo *servo, float degree);
static	float	SensorAngle(TMpu6050Value* sensor);
static	float	Trimmimg(float srcValue, float minValue, float maxValue);
static	float	SensorAngleAverage(float angle);
static	ESeesawTilt	SeesawTilt(float sensorAngle);
static	float	MoveOutputServo(TServo *servo, ESeesawTilt seesawTilt);
static	float	OutputServoDegree(float degree, float degreeStep, ESeesawTilt seesawTilt);

//ADCX[vA
ISR(ADC_vect)
{
	//Ȃ
}

int main(void)
{
	WaitSec(1);
	
	//USẴ|[g͕EvAbvɐݒ肷
	DDRB	=	0x00;	PORTB	=	0xFF;
	DDRC	=	0x00;	PORTC	=	0xFF;
	DDRD	=	0x00;	PORTD	=	0xFF;
	
	//d͍팸
	PRR		=	(0<<PRTWI) | (1<<PRTIM2) | (0<<PRTIM0) | (1<<PRTIM1) | (1<<PRSPI) | (1<<PRUSART0) | (0<<PRADC);
	ACSR	=	(1<<ACD);		//AiORp[^s
	DIDR0	=	(1<<ADC0D);		//ADC0s̃fW^͕s
	
	//ADC̊dƓ̓sݒ肷
	//REFS1,0	->	00:AREF, 01:AVCC, 10:(\), 11:1.1V
	//MUX0		->	0000-0111:PA0-PA7, 1000:x, 1110:I1.1Vڑ, 1111:I0Vڑ
	ADMUX = (0b01<<REFS0) | (0b0000<<MUX0);
	
	//ADC̓ݒ肷
	//ADEN	->	1:ADCL
	//ADIE	->	1:ADC荞݋
	//ADPS2-0	->	ADC(50k`200kHzK)
	//				000;001:2, 010:4, 011:8, 100:16, 101:32, 110:64, 111:128
	ADCSRA = (1<<ADEN) | (1<<ADIE) | (0b110<<ADPS0);	//8MHz/64=125kHz
	
	//I2C,LCD
	TWI_MasterInit();
	I2CLCD_Init(I2CLCD_DEFAULT_SLA, 16, 2);
	I2CLCD_SetLineMode(LCD_LINEMODE_COMBINE | LCD_LINEMODE_OVERWRITE, LCD_CURSOR_ON);
	I2CLCD_PutString("LCD-OK.");

	//ZT[
	uint8_t	isOK = MPU6050_Init();
	if (!isOK) { I2CLCD_PutString("Sens-NG.");	goto FINISH; }
	I2CLCD_PutString("Sens-OK.");
	
	//T[{
	TServo	servoInput, servoOutput;
	SG90_Init((1<<PORT0)|(1<<PORT1));
	SG90_InitServo(&servoInput, PORT0, SV_INPUT_DEG_0, SV_INPUT_DEG_180);
	SG90_InitServo(&servoOutput, PORT1, SV_OUTPUT_DEG_0, SV_OUTPUT_DEG_180);
	
	TMpu6050Value	sensor;
	uint8_t	loopCount = 0;
	
	while (1)
	{
		//{[̒l擾
		uint16_t	volumeAdc = VolumeAdc();
		
		//{[̒l̓T[{̉]pɕϊ
		float	inputDegree = VolumeToDegree(volumeAdc);
		
		//̓T[{ẘpxɓ
		MoveInputServo(&servoInput, inputDegree);
		
		//ZT[̌XΊp擾
		MPU6050_GetValue(&sensor);
		float	sensorAngle = SensorAngle(&sensor);
		
		//ZT[̌XΊpV[\[̌XΏԂɕϊ
		ESeesawTilt	seesawTilt = SeesawTilt(sensorAngle);
		
		//V[\[ɂȂ֏o̓T[{𓮂
		float	outputDegree = MoveOutputServo(&servoOutput, seesawTilt);
		
		//\
		if (loopCount % 0x80 == 0)
		{
			I2CLCD_Clear();	_delay_ms(3);
			I2CLCD_SetPos(0, 0);
			I2CLCD_PutString("VR:");	I2CLCD_PutUInt(volumeAdc);	I2CLCD_PutChar(' ');
			I2CLCD_PutString("IN:");	I2CLCD_PutInt(inputDegree);
			I2CLCD_SetPos(1, 0);
			I2CLCD_PutString("S*10:");	I2CLCD_PutInt(sensorAngle * 10);	I2CLCD_PutChar(' ');
			I2CLCD_PutString("OUT:");	I2CLCD_PutInt(outputDegree);
		}
		loopCount++;
	}
	
FINISH:
	return 0;
}

//ԑ҂
static	void	WaitSec(uint8_t sec)
{
	for (uint8_t i = 0; i < sec * 10; i++) { _delay_ms(100); }
}

//{[l擾
//߂lF	0`1023
static	uint16_t	VolumeAdc(void)
{
	set_sleep_mode(SLEEP_MODE_ADC);
	sleep_mode();	//ADCJn^
	uint16_t adcValue = ADC;	//ϊlo
	return adcValue;
}

//{[lT[{̉]pɕϊ
//E͑T[{̃T[{z[́Aと̈ړ0180x̕B
//E{[̉]ƃT[{̉]킹̂̊֐Bc(*)
//	volumeAdc: 0`1023
//߂lF	SV_DEGREE_UPPER_LIMITȏASV_DEGREE_LOWER_LIMITȉ̒l
static	float	VolumeToDegree(uint16_t volumeAdc)
{
	float degree = volumeAdc / 1023.0 * (SV_DEGREE_LOWER_LIMIT - SV_DEGREE_UPPER_LIMIT) + SV_DEGREE_UPPER_LIMIT;
	return degree;
	//return 180.0 - degree;	(*)cu̍łȂꍇ
}

//̓T[{ẘpxɓ
static	void	MoveInputServo(TServo *servo, float degree)
{
	SG90_Degree(servo, degree);
}

//ZT[̌XΊp擾
//߂l:	-90.0 <= angle <= 90.0
static	float	SensorAngle(TMpu6050Value* sensor)
{
	float angle = Trimmimg(sensor->angle.x, -90.0, 90.0);
	angle = SensorAngleAverage(angle);
	return angle;
}

//pxg~O
static	float	Trimmimg(float srcValue, float minValue, float maxValue)
{
	if (srcValue < minValue) { srcValue = minValue; }
	if (maxValue < srcValue) { srcValue = maxValue; }
	return srcValue;
}

//ZT[̌XΊp𕽊
#define SA_BUFSIZE	8
static	float	SensorAngleAverage(float angle)
{
	static	float	buf[SA_BUFSIZE] = { SV_DEGREE_DEFAULT };
	static	uint8_t	idx = 0;
	
	buf[idx] = angle;
	if (++idx == SA_BUFSIZE) { idx = 0; }
	
	float	avg = 0.0;
	for (uint8_t i = 0; i < SA_BUFSIZE; i++) { avg += buf[i]; }
	avg /= SA_BUFSIZE;
	return avg;	
}

//V[\[̌XΏԂ𒲂ׂ
//F	ZT[̌XΊp
//		c̓T[{̕ӂĂ
//		c̓T[{̕ӂオĂ
static	ESeesawTilt	SeesawTilt(float sensorAngle)
{
	//0.0xߕӂ̓KȔ͈͂𐅕ƌȂ
	if (0.5 < sensorAngle) { return SEESAW_INPUTSIDE_DOWN; }
	if (sensorAngle < -0.5) { return SEESAW_INPUTSIDE_UP; }
	return SEESAW_NEUTRAL;
}

//V[\[ɂȂ֏o̓T[{𓮂
#define SV_DEGREE_OUTPUTSIDE_STEP	0.5
static	float	MoveOutputServo(TServo *servo, ESeesawTilt seesawTilt)
{
	static	ESeesawTilt	prevSeesawTilt = SEESAW_NEUTRAL;
	static	float	degreeStep = SV_DEGREE_OUTPUTSIDE_STEP;
	static	float	outputDegree = SV_DEGREE_DEFAULT;
	
	if (seesawTilt != SEESAW_NEUTRAL)
	{
		//O̓w肩炠x܂ōĎw肵Ȃ
		if (!SG90_IsMoving(servo)) { goto FINISH; }

		//V[\[XĂ
		if (prevSeesawTilt != seesawTilt) { degreeStep /= 2; }	//ʂzČXtɂȂApx̍ݕ𔼌
		outputDegree = OutputServoDegree(outputDegree, degreeStep, seesawTilt);		//Xɉĉ]p߂
		SG90_Degree(servo, outputDegree);
	}
	else
	{
		//V[\[ɂȂ
		degreeStep = SV_DEGREE_OUTPUTSIDE_STEP;		//px̍ݕlɖ߂
	}
	
	//̌Xۑ
	prevSeesawTilt = seesawTilt;

FINISH:
	return outputDegree;
}

//ZT[̌X΂ɉďo͑T[{̊pxXV
//EZT[̌XΕƃT[{̉]킹̂̊֐Bc(*)
static	float	OutputServoDegree(float degree, float degreeStep, ESeesawTilt seesawTilt)
{
	if (seesawTilt == SEESAW_OUTPUTSIDE_UP) { degree -= degreeStep; }
	if (seesawTilt == SEESAW_OUTPUTSIDE_DOWN) { degree += degreeStep; }

	degree = Trimmimg(degree, SV_DEGREE_UPPER_LIMIT, SV_DEGREE_LOWER_LIMIT);
	return degree;
	//return 180.0 - degree;	(*)cu̍łȂꍇ
}
