//	3{3ZT[MPU6050Cu
//	wt]xH쎺	http://jsdiy.webcrow.jp
//	2018/07

#ifndef MPU6050LIB_H_
#define MPU6050LIB_H_


typedef	struct
{
	int16_t	x;
	int16_t	y;
	int16_t	z;
}
TIAxis;

typedef	struct
{
	float	x;
	float	y;
	float	z;
}
TFAxis;

typedef	struct
{
	TFAxis	angle;	//ʂɑ΂ZT[̌X(-180`+180x)	Z̒l͂قږӖ
	TFAxis	degps;	//bx̑ŉ]Ă邩(degree per second)
	float	temperature;
}
TMpu6050Value;

//FS_SEL selects the full scale range of the gyroscope outputs according to the following table.
typedef	enum
{
	MPU6050_GYRO_SCALE_250deg,	//'0':}250/s  -> 131 LSB//s
	MPU6050_GYRO_SCALE_500deg,	//'1':}500/s  -> 65.5 LSB//s
	MPU6050_GYRO_SCALE_1000deg,	//'2':}1000/s -> 32.8 LSB//s
	MPU6050_GYRO_SCALE_2000deg,	//'3':}2000/s -> 16.4 LSB//s
	MPU6050_GYRO_SCALE_DEFAULT = 0
}
EMpu6050GyroScale;

//AFS_SEL selects the full scale range of the accelerometer outputs according to the following table.
typedef	enum
{
	MPU6050_ACCEL_SCALE_2G,		//'0':}2g  -> 16384 LSB/g
	MPU6050_ACCEL_SCALE_4G,		//'1':}4g  -> 8192 LSB/g
	MPU6050_ACCEL_SCALE_8G,		//'2':}8g  -> 4096 LSB/g
	MPU6050_ACCEL_SCALE_16G,	//'3':}16g -> 2048 LSB/g
	MPU6050_ACCEL_SCALE_DEFAULT = 0
}
EMpu6050AccelScale;

//֐
uint8_t	MPU6050_Init(void);
uint8_t	MPU6050_Init2(EMpu6050GyroScale gscale, EMpu6050AccelScale ascale);
void	MPU6050_GetValue(TMpu6050Value* retValue);


#endif	//MPU6050LIB_H_
